# gcp_appengine_firewall_rule – Creates a GCP FirewallRule

New in version 2.9.

- Synopsis
- Requirements
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- A single firewall rule that is evaluated against incoming traffic and provides an action to take on matched requests.

## Requirements

The below requirements are needed on the host that executes this module.

- python >= 2.6
- requests >= 2.18.4
- google-auth >= 1.3.0

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
action string / required |  | The action to take if this rule matches. Some valid choices include: "UNSPECIFIED_ACTION", "ALLOW", "DENY"

auth_kind
string / required

Choices:
- application
- machineaccount
- serviceaccount

The type of credential used.

description string |  | An optional string description of this rule.
env_type string |  | Specifies which Ansible environment you're running this module within. This should not be set unless you know what you're doing. This only alters the User Agent string for any API requests.
priority integer |  | A positive integer that defines the order of rule evaluation. Rules with the lowest priority are evaluated first. A default rule at priority Int32.MaxValue matches all IPv4 and IPv6 traffic when no previous rule matches. Only the action of this rule can be modified by the user.
project string |  | The Google Cloud Platform project to use.
scopes list |  | Array of scopes to be used.
service_account_contents jsonarg |  | The contents of a Service Account JSON file, either in a dictionary or as a JSON string that represents it.
service_account_email string |  | An optional service account email address if machineaccount is selected and the user does not wish to use the default email.
service_account_file path |  | The path of a Service Account JSON file if serviceaccount is selected as type.
source_range string / required |  | IP address or range, defined using CIDR notation, of requests that this rule applies to.

state
string

Choices:
- present ←
- absent

Whether the given object should exist in GCP

## Notes

Note

- API Reference: https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.firewall.ingressRules
- Official Documentation: https://cloud.google.com/appengine/docs/standard/python/creating-firewalls#creating_firewall_rules
- for authentication, you can set service_account_file using the c(gcp_service_account_file) env variable.
- for authentication, you can set service_account_contents using the c(GCP_SERVICE_ACCOUNT_CONTENTS) env variable.
- For authentication, you can set service_account_email using the `GCP_SERVICE_ACCOUNT_EMAIL` env variable.
- For authentication, you can set auth_kind using the `GCP_AUTH_KIND` env variable.
- For authentication, you can set scopes using the `GCP_SCOPES` env variable.
- Environment variables values will only be used if the playbook values are not set.
- The service_account_email and service_account_file options are mutually exclusive.

## Examples

    - name: create a firewall rule
      gcp_appengine_firewall_rule:
        priority: 1000
        source_range: 10.0.0.0
        action: ALLOW
        project: test_project
        auth_kind: serviceaccount
        service_account_file: "/tmp/auth.pem"
        state: present

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
action string | success | The action to take if this rule matches.
description string | success | An optional string description of this rule.
priority integer | success | A positive integer that defines the order of rule evaluation. Rules with the lowest priority are evaluated first. A default rule at priority Int32.MaxValue matches all IPv4 and IPv6 traffic when no previous rule matches. Only the action of this rule can be modified by the user.
sourceRange string | success | IP address or range, defined using CIDR notation, of requests that this rule applies to.

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Community. [community]

### Authors

- Google Inc. (@googlecloudplatform)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.